#define SUPPORT_DUBLIN
inline void IO_InitDublin(void)
{
	VALUE_SET(id                 , GOTYPE_DUBLIN);
	VALUE_SET(caseid             , GOCASE_DUBLIN);
	VALUE_SET(cputype            , GOCPU_S3C2443);

	VALUE_SET(btchip             , GOBT_BC4);
	VALUE_SET(btspeed            , 921600);
	VALUE_SET(btclock            , 16000000);
	VALUE_SET(btclass            , 0x280408);
	VALUE_SET(handsfree          , 1);
	VALUE_SET(headsetgw          , 1);
	VALUE_SET(a2dp               , 1);

	VALUE_SET(chargertype        , GOCHARGER_LTC3455);
	VALUE_SET(chargerresistor    , 1780);
	VALUE_SET(sdcard             , 1);
	VALUE_SET(sdslot             , 1);
	VALUE_SET(internalflash      , 1);
	VALUE_SET(hsmmcinterface     , 1);
	VALUE_SET(tfttype            , GOTFT_SAMSUNG_LTE430WQ);

	VALUE_SET(gpstype            , GOGPS_SIRF3);
	VALUE_SET(codectype          , GOCODEC_WM8971);
	VALUE_SET(codecmaster        , GOCODECCFG_SLAVE);
	VALUE_SET(usbslavetype       , GOUSB_S3C2443);
	VALUE_SET(ohciports          , 0x01);
	VALUE_SET(usbdevicehostcapable,1);
	VALUE_SET(regulatorforcodec  , 1);
	VALUE_SET(keeprtcpowered     , 1);
	VALUE_SET(canrecordaudio     , 1);
	VALUE_SET(hw_i2c             , 1);
	VALUE_SET(pnp                , 1);
	VALUE_SET(usbhost            , 1);
	VALUE_SET(codecamptype       , GOCODECAMP_DIFFERENTIAL_HW);
	VALUE_SET(aectype            , GOAEC_FM);
	VALUE_SET(loquendo           , 1);
	VALUE_SET(gpsephemeris       , 1);

	VALUE_SET(tsxchannel         , 5);
	VALUE_SET(tsychannel         , 9);
	VALUE_SET(tsdownchannel      , 9);

	VALUE_SET(videodecoder       , GOVD_ADV7180);
	VALUE_SET(deadreckoning      , 1);
	VALUE_SET(temperaturesensor  , 1);

	STRING_SET(familyname,"TomTom");
	STRING_SET(projectname,"DUBLIN");
	STRING_SET(requiredbootloader,"5.4104");
	STRING_SET(dockdev,"ttySAC0");
	STRING_SET(btdev,"ttySAC1");
	STRING_SET(gpsdev,"ttySAC2");
	STRING_SET(hudev,"ttySAC3");
	STRING_SET(btname,"TomTom");
	STRING_SET(usbname,"TomTom");	
#ifndef __BOOTLOADER__
	STRING_SET(name,"TomTom");
#endif

	PIN_SET(SD_PWR_ON          , PIN_GPJ13);
	PIN_SET(HS_MOVI_PWR_ON     , PIN_GPJ14 | PIN_INVERTED);
	PIN_SET(WP_SD              , PIN_GPF7);
	PIN_SET(CD_SD              , PIN_GPF1 | PIN_INVERTED);

	PIN_SET(GPS_RESET          , PIN_GPE13 | PIN_INVERTED);
	PIN_SET(GPS_ON             , PIN_GPE12);
	PIN_SET(GPS_1PPS           , PIN_GPG0);
	PIN_SET(GPS_REPRO          , PIN_GPE11);
	PIN_SET(TXD_GPS            , PIN_GPH4);
	PIN_SET(RXD_GPS            , PIN_GPH5);

	PIN_SET(ON_OFF             , PIN_GPF0 | PIN_INVERTED);
	PIN_SET(ACPWR              , PIN_GPF2 | PIN_INVERTED);
	PIN_SET(PWR_RST            , PIN_GPG10);
	PIN_SET(CHARGING           , PIN_GPG1 | PIN_INVERTED);
	PIN_SET(AIN4_PWR           , PIN_GPA11);
	PIN_SET(BATT_TEMP_OVER     , PIN_GPF4 | PIN_INVERTED);
	PIN_SET(USB_HP             , PIN_GPH12);
	PIN_SET(USB_SUSPEND_OUT    , PIN_GPH8);
	PIN_SET(USB_PWR_BYPASS     , PIN_GPG5); // called CHARGE_OUT in schematics.
	PIN_SET(PWR_MODE           , PIN_GPG6);	
	PIN_SET(LOW_DC_VCC         , PIN_GPF6 | PIN_INVERTED);

	PIN_SET(LINEIN_DETECT      , PIN_GPF3 | PIN_INVERTED);

	PIN_SET(TXD_DOCK           , PIN_GPH0);
	PIN_SET(RXD_DOCK           , PIN_GPH1);

	PIN_SET(AMP_ON             , PIN_GPG11);
	PIN_SET(DAC_PWR_ON         , PIN_GPJ15);
	PIN_SET(HEADPHONE_DETECT   , PIN_GPG4 | PIN_INVERTED);
	PIN_SET(I2SSDO             , PIN_GPE4);
	PIN_SET(CDCLK              , PIN_GPE2);
	PIN_SET(CDCLK_12MHZ        , PIN_GPH13);
	PIN_SET(I2SSCLK            , PIN_GPE1);
	PIN_SET(I2SLRCK            , PIN_GPE0);
	PIN_SET(I2SSDI             , PIN_GPE3);
	PIN_SET(L3CLOCK            , PIN_GPB4);
	PIN_SET(L3MODE             , PIN_GPB3);
	PIN_SET(L3DATA             , PIN_GPB2);

	PIN_SET(TXD_BT             , PIN_GPH2);
	PIN_SET(RXD_BT             , PIN_GPH3);
	PIN_SET(RTS_BT             , PIN_GPH11);
	PIN_SET(CTS_BT             , PIN_GPH10);
	PIN_SET(BT_RESET           , PIN_GPG9 | PIN_INVERTED);

	PIN_SET(LCD_VCC_PWREN      , PIN_GPC6 | PIN_INVERTED);
	PIN_SET(BACKLIGHT_PWM      , PIN_GPB0 | PIN_INVERTED);
	PIN_SET(BACKLIGHT_EN       , PIN_GPB1);
	PIN_SET(LCD_RESET          , PIN_GPC0 | PIN_INVERTED);
	PIN_SET(LCD_ID             , PIN_GPC7);

	PIN_SET(USB_HOST_DETECT    , PIN_GPF2 | PIN_INVERTED);
	PIN_SET(IGNITION           , PIN_GPF2 | PIN_INVERTED);
	PIN_SET(USB_PHY_PWR_EN     , PIN_GPG8);

	PIN_SET(HW_IIC_SDA         , PIN_GPE15);
	PIN_SET(HW_IIC_SCL         , PIN_GPE14);

	PIN_SET(XMON               , PIN_GPG13 | PIN_OPEN_COLLECTOR);
	PIN_SET(XPON               , PIN_GPG12 | PIN_OPEN_EMITTER);
	PIN_SET(YMON               , PIN_GPG15 | PIN_OPEN_COLLECTOR);
	PIN_SET(YPON               , PIN_GPG14 | PIN_OPEN_EMITTER);
	PIN_SET(TSDOWN             , PIN_GPG15 | PIN_OPEN_COLLECTOR);

	PIN_SET(LOW_CORE           , PIN_GPG7 | PIN_INVERTED);
	PIN_SET(LX_EN              , PIN_GPL13);

	PIN_SET(CAM_DPWDN          , PIN_GPC5 | PIN_INVERTED);
	PIN_SET(CAM_DIRQ           , PIN_GPG3 | PIN_INVERTED);
	PIN_SET(CAMRESET           , PIN_GPJ12);
	PIN_SET(CAMCLKOUT          , PIN_GPJ11);
	PIN_SET(CAMPCLK            , PIN_GPJ8);
	PIN_SET(CAMVSYNC           , PIN_GPJ9);
	PIN_SET(CAMHREF            , PIN_GPJ10);
	PIN_SET(CAMDATA0           , PIN_GPJ0);
	PIN_SET(CAMDATA1           , PIN_GPJ1);
	PIN_SET(CAMDATA2           , PIN_GPJ2);
	PIN_SET(CAMDATA3           , PIN_GPJ3);
	PIN_SET(CAMDATA4           , PIN_GPJ4);
	PIN_SET(CAMDATA5           , PIN_GPJ5);
	PIN_SET(CAMDATA6           , PIN_GPJ6);
	PIN_SET(CAMDATA7           , PIN_GPJ7);

	PIN_SET(EN_DR_PWR          , PIN_GPL13); /* for photo sensor power */

	PIN_SET(UART_INTA          , PIN_GPG2 | PIN_INVERTED);
	PIN_SET(UART_RESET         , PIN_GPH9 | PIN_INVERTED);

	PIN_SET(DOCK_RADIO_SENSE   , PIN_GPF3 | PIN_INVERTED);
	PIN_SET(HU_PWR_ON          , PIN_GPF5 | PIN_INVERTED);
	PIN_SET(HU_PWR_HOLD        , PIN_GPL12 | PIN_INVERTED);
	PIN_SET(TXD_HU             , PIN_GPH6 );
	PIN_SET(RXD_HU             , PIN_GPH7 );

	PIN_SET(FACTORY_TEST_POINT , PIN_GPL14);

	/* additions for quiescent current limitation */
	PIN_SET(CLKOUT,			PIN_GPH14);

	PIN_SET(RSMBWAIT,		PIN_GPM0);
	PIN_SET(FR_N_B,			PIN_GPM1);

	PIN_SET(N_XBACK,		PIN_GPB5);
	PIN_SET(N_XBREQ,		PIN_GPB6);
	PIN_SET(N_XDACK_1,		PIN_GPB7);
	PIN_SET(N_XDREQ_1,		PIN_GPB8);
	PIN_SET(N_XDACK_0,		PIN_GPB9);
	PIN_SET(N_XDREQ_0,		PIN_GPB10);
	
	PIN_SET(SD0_DAT0,		PIN_GPL0);
	PIN_SET(SD0_DAT1,		PIN_GPL1);
	PIN_SET(SD0_DAT2,		PIN_GPL2);
	PIN_SET(SD0_DAT3,		PIN_GPL3);
	PIN_SET(SD0_DAT4,		PIN_GPL4);
	PIN_SET(SD0_DAT5,		PIN_GPL5);
	PIN_SET(SD0_DAT6,		PIN_GPL6);
	PIN_SET(SD0_DAT7,		PIN_GPL7);
	PIN_SET(SD0_CMD,		PIN_GPL8);
	PIN_SET(SD0_CLK,		PIN_GPL9);
	
	PIN_SET(SD1_CLK,		PIN_GPE5);
	PIN_SET(SD1_CMD,		PIN_GPE6);
	PIN_SET(SD1_DAT0,		PIN_GPE7);
	PIN_SET(SD1_DAT1,		PIN_GPE8);
	PIN_SET(SD1_DAT2,		PIN_GPE9);
	PIN_SET(SD1_DAT3,		PIN_GPE10);
}

/* B1, B2 and C1 are not the final versions, so it is a good idea to identify them as such for now */
void IO_InitDublinB1(void)
{
#ifdef __BOOTLOADER__
	STRING_SET(name,"TomTom Dublin B1");
#endif

	PIN_SET(NAVI_MUTE          , PIN_GPL11 | PIN_INVERTED);
	PIN_SET(TEL_MUTE           , PIN_GPL10 | PIN_INVERTED);
}

void IO_InitDublinB2(void)
{
#ifdef __BOOTLOADER__
	STRING_SET(name,"TomTom Dublin B2");
#endif

	PIN_SET(NAVI_MUTE          , PIN_GPL11 );
	PIN_SET(TEL_MUTE           , PIN_GPL10 );
}

void IO_InitDublinC1(void)
{
#ifdef __BOOTLOADER__
	STRING_SET(name,"TomTom Dublin C1");
#endif

	PIN_SET(NAVI_MUTE          , PIN_GPL11 );
	PIN_SET(TEL_MUTE           , PIN_GPL10 );
}

void IO_InitDublinC2(void)
{
#ifdef __BOOTLOADER__
	STRING_SET(name,"TomTom Dublin C2");
#endif

	PIN_SET(NAVI_MUTE          , PIN_GPL11 );
	PIN_SET(TEL_MUTE           , PIN_GPL10 );
}
