/* Special cases when going into suspend mode (default is deactivation on suspend) */

#undef	SC16IS740_SLEEP_MODE

inline void IO_SuspendDetectionPins(void)
{
	/* Make sure no current is drawn by hardware detection resistors */
	IO_Suspend(TYPE_MAIN_ID0);
	IO_Suspend(TYPE_MAIN_ID1);
	IO_Suspend(TYPE_MAIN_ID2);
	IO_Suspend(TYPE_NEC_LCD);
	IO_Suspend(TYPE_SUB_ID0);
	IO_Suspend(TYPE_SUB_ID1);
	IO_Suspend(FLEX_ID1);
	IO_Suspend(FLEX_ID2);
	IO_Suspend(LCD_ID);
	IO_Suspend(PIC_DETECT);
}

inline void IO_InitSuspend(void)
{
	/* Make sure no current is drawn by hardware detection resistors */
	if (IO_GetInput(TYPE_MAIN_ID0)) PIN_ADD_MASK(TYPE_MAIN_ID0, PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(TYPE_MAIN_ID1)) PIN_ADD_MASK(TYPE_MAIN_ID1, PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(TYPE_MAIN_ID2)) PIN_ADD_MASK(TYPE_MAIN_ID2, PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(TYPE_NEC_LCD))  PIN_ADD_MASK(TYPE_NEC_LCD , PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(TYPE_SUB_ID0))  PIN_ADD_MASK(TYPE_SUB_ID0 , PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(TYPE_SUB_ID1))  PIN_ADD_MASK(TYPE_SUB_ID1 , PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(FLEX_ID1))      PIN_ADD_MASK(FLEX_ID1     , PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(FLEX_ID2))      PIN_ADD_MASK(FLEX_ID2     , PIN_ACTIVATE_ON_SUSPEND);
	if (IO_GetInput(LCD_ID))        PIN_ADD_MASK(LCD_ID       , PIN_INPUT_ON_SUSPEND);
	if (IO_HavePicDetected())	      PIN_ADD_MASK(PIC_DETECT   , PIN_INPUT_ON_SUSPEND);
	
	/* Other pins which need to be low or high or input */
	PIN_ADD_MASK(CD_SD             , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(WP_SD             , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(EN_SD             , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(CHARGEFAULT       , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(CHARGING          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(BATT_TEMP_OVER    , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(LIGHTS_DETECT     , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(DOCK_SENSE        , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(DOCK_CRIB_SENSE   , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(DOCK_RADIO_SENSE  , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(DOCK_INT          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(LINEIN_DETECT     , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(FSK_IRQ           , PIN_INPUT_ON_SUSPEND);
	if (IO_HaveRemote())
	{
		PIN_ADD_MASK(SPIMSO            , PIN_INPUT_ON_SUSPEND);
	}
	PIN_ADD_MASK(HEADPHONE_DETECT  , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(EXTMIC_DETECT     , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(CTS_DOCK          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(RTS_DOCK          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(TXD_DOCK          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(RXD_DOCK          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(RXD_DOCK_INT      , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(RXD_BT            , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(CTS_BT            , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(USB_HOST_DETECT   , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(ON_OFF            , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(IGNITION          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(LOW_DC_VCC        , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(ACPWR             , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(HDD_IRQ           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(HDD_LED           , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(HDD_RST           , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(USB_RST           , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(LCD_RESET         , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(LCD_CS            , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(BT_RESET          , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(USB_DREQ          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(USB_IRQ           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(USB_HP            , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(CAM_DPWDN         , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(FACTORY_TEST_POINT, PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(XPON              , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(YPON              , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(GSM_SYNC          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_WAKEUP        , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(UART_PWRSAVE      , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(UART_RXD_IPOD     , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(UART_RXD_TMC      , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(UART_INTA         , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(UART_INTB         , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(UART_RESET        , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(MEP_DAT           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(MEP_ACK           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(TOUCHPAD_SW       , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(MEP_CLK           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(ACC_SPI_CSB       , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(CMP_SPI_CSB       , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(DR_CMP_RST        , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(FM_RST            , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(GSM_RXD           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_CTS           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_DSR           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_DCD           , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_RING          , PIN_INPUT_ON_SUSPEND);
	PIN_ADD_MASK(GSM_PORT_SEL      , PIN_ACTIVATE_ON_SUSPEND);
	PIN_ADD_MASK(GSM_RESET         , PIN_ACTIVATE_ON_SUSPEND);

	/* S3C2412 cannot set output high in sleep mode. only input mode is possible. */
	if ( IO_HaveCamera() || (IO_GetI2cSuspendLevel() == PIN_INPUT_ON_SUSPEND) ) {
		PIN_ADD_MASK(HW_IIC_SDA        , PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(HW_IIC_SCL        , PIN_INPUT_ON_SUSPEND);
	}

	if (IO_HaveGlDetected())
	{
		PIN_ADD_MASK(GPS_REPRO       , PIN_INPUT_ON_SUSPEND);  
	}
	else
	{
		PIN_ADD_MASK(GPS_RESET       , PIN_ACTIVATE_ON_SUSPEND);
	}

	if (IO_GetModelId() != GOTYPE_NEWCASTLE)
	{
		/* The addition of these pins caused newcastle have a 3.5mA suspend current */
		PIN_ADD_MASK(CAM_DIRQ,		PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(HU_PWR_ON,		PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(SW_SDA,		PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(RXD_HU,		PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(NAV_MUTE_DIAG, PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(UART_CLK,		PIN_ACTIVATE_ON_SUSPEND);
	}


	PIN_ADD_MASK(PWR_HOLD,		PIN_ACTIVATE_ON_SUSPEND);
	

	if (IO_GetModelId() == GOTYPE_MARIGOT)
	{
		PIN_ADD_MASK(RDS_RST       ,PIN_ACTIVATE_ON_SUSPEND);
		PIN_ADD_MASK(RDS_SEN       ,PIN_ACTIVATE_ON_SUSPEND);
		PIN_ADD_MASK(FM_RDS_INT    ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(RDS_GPIO3     ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(RXTRIGGER     ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(GPS_ANT_SHORT ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(GPS_ANT_OPEN  ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(GPS_1PPS      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA0      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA1      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA2      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA3      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA4      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA5      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA6      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMDATA7      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMPCLK       ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMVSYNC      ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAMHREF       ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAN_RESERV    ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAN_RESETIN   ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(BL_EN_STAT	   ,PIN_INPUT_ON_SUSPEND);
		PIN_ADD_MASK(CAN_RESETOUT  ,PIN_ACTIVATE_ON_SUSPEND);
	}
	else
	{
		PIN_ADD_MASK(BT_MODE       ,PIN_ACTIVATE_ON_SUSPEND);
		if (IO_GetModelId() != GOTYPE_NEWCASTLE)
		{
			/* The addition of these pins (look for other occurence above) caused newcastle have a 3.5mA suspend current */
			PIN_ADD_MASK(CAMRESET      ,PIN_ACTIVATE_ON_SUSPEND);
		}
	}

	if (IO_GetModelId() == GOTYPE_DUBLIN) {
		/* for dublin some overrides are in place for suspend mode pin configuration
		 * this is due to the lack of configuring pull resistors in suspend mode in the
		 * current administration setup.. */
	}
}

/* just before IO_PowerOff() actually sets the pin configuration for suspend mode this
 * 'hook' function is called to override some pin configuration settings that are
 * unsettable/clearable in current administration setup */
inline void IO_InitSuspendEx(void)
{
	if ((IO_GetCpuType() == GOCPU_S3C2443) &&
		(IO_GetModelId() == GOTYPE_DUBLIN)) {
#ifdef __KERNEL__
		printk(KERN_INFO "%s: enforcing dublin specific pin configuration overrides for suspend mode\n", __FUNCTION__);
#endif
		/* dublin specific io pin configuration for suspend mode
		 * all previous masks are overridden with these new ones.. this includes the
		 * masks for e.g. inverted, floating, open-collector pins.. */
		PIN_SET_MASK(PWR_MODE,		PIN_ACTIVATE_ON_SUSPEND);		/* output/high */
		PIN_SET_MASK(BACKLIGHT_PWM,	PIN_INPUT_ON_SUSPEND);			/* input no-pull */
		PIN_SET_MASK(UART_RESET,	PIN_ACTIVATE_ON_SUSPEND);		/* output/high */
		PIN_SET_MASK(RXD_DOCK,		PIN_INPUT_ON_SUSPEND);			/* input/no-pull */
		PIN_SET_MASK(TXD_DOCK,		0);					/* output/low */
		PIN_SET_MASK(RXD_GPS,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);	/* input/pull-down */
		PIN_SET_MASK(GPS_REPRO,		0);					/* output/low */
		PIN_SET_MASK(FACTORY_TEST_POINT,0);					/* output/low */
		PIN_SET_MASK(CDCLK_12MHZ,	PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);	/* input/pull-down */

		/* camera stuff.. */
		PIN_SET_MASK(CAMDATA0,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA1,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA2,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA3,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA4,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA5,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA6,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMDATA7,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMPCLK,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMVSYNC,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMHREF,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAMCLKOUT,		0);
		PIN_SET_MASK(CAMRESET,		PIN_ACTIVATE_ON_SUSPEND);
		PIN_SET_MASK(CAM_DPWDN,		0);

		/* we read HU_PWR_ON in tomtomgo-wake so the inverted part has to confirm with the original I/O definition */
		PIN_SET_MASK(HU_PWR_ON,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND | PIN_INVERTED);
		/* be sure to restore the previous pin configuration on resume
		 * as this setting causes 'low battery warning' after resume..! */
		PIN_SET_MASK(LOW_DC_VCC,	PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(UART_INTA,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(CAM_DIRQ,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);

		/* touchscreen
		 * be sure to restore the previous pin configuration on resume
		 * as this setting causes the touchscreen to not function anymore
		 * after resume..! */
		PIN_SET_MASK(XPON,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(XMON,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(YPON,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(YMON,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(TSDOWN,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);

		/* i2s */
		PIN_SET_MASK(I2SSDI,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		
		/* i2c */
		PIN_SET_MASK(HW_IIC_SCL,	PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(HW_IIC_SDA,	PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);

		PIN_SET_MASK(AIN4_PWR,		PIN_PULL_DOWN | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(GPS_ON,		0);	/* output/low */
		/* gps rest
		 * be sure to restore the previous pin configuration on resume
		 * as this setting causes resume not to not function anymore..! */
		PIN_SET_MASK(GPS_RESET,		0);	/* output/low */

		/* !! - newly introduced pins - !! */
		
#if defined(SC16IS740_SLEEP_MODE)
		/* do not disable clk when investigating sc16is740 'sleep mode'..! 
		 * use this when controlling sc16is2740 externally for example.. */
		PIN_SET_MASK(CLKOUT,		PIN_IGNORE_ON_SUSPEND);
#else	/* ! SC16IS740_SLEEP_MODE */
		/* clk for external iic uart sc16is740 */
		PIN_SET_MASK(CLKOUT,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
#endif	/* SC16IS740_SLEEP_MODE */

		PIN_SET_MASK(RSMBWAIT,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(FR_N_B,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);

		/* movinand interface */
		PIN_SET_MASK(SD0_DAT0,		0);
		PIN_SET_MASK(SD0_DAT1,		0);
		PIN_SET_MASK(SD0_DAT2,		0);
		PIN_SET_MASK(SD0_DAT3,		0);
		PIN_SET_MASK(SD0_DAT4,		0);
		PIN_SET_MASK(SD0_DAT5,		0);
		PIN_SET_MASK(SD0_DAT6,		0);
		PIN_SET_MASK(SD0_DAT7,		0);
		PIN_SET_MASK(SD0_CMD,		0);
		PIN_SET_MASK(SD0_CLK,		0);
		
		/* sd card interface */
		PIN_SET_MASK(SD1_CLK,		0);
		PIN_SET_MASK(SD1_CMD,		0);
		PIN_SET_MASK(SD1_DAT0,		0);
		PIN_SET_MASK(SD1_DAT1,		0);
		PIN_SET_MASK(SD1_DAT2,		0);
		PIN_SET_MASK(SD1_DAT3,		0);

		/* optional pull-up resistors */
		PIN_SET_MASK(N_XBACK,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(N_XBREQ,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(N_XDACK_1,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(N_XDREQ_1,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(N_XDACK_0,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
		PIN_SET_MASK(N_XDREQ_0,		PIN_PULL_UP | PIN_INPUT_ON_SUSPEND);
	}	/* dublin specifics */
}

/* EOF */
