/* linux/include/asm/arch-s3c2410/regs-camif.h
 *
 * Copyright (c) 2006 TomTom BV, http://www.tomtom.nl
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * S3C2413 Internal CAMIF register definition
 */

#ifndef __ASM_ARCH_REGS_CAMIF_H
#define __ASM_ARCH_REGS_CAMIF_H

#include <asm/arch/map.h>

#define S3C2413_CAMIFREG(x)			((x) + S3C24XX_VA_CAMIF)

#define S3C2413_CISRCFMT			S3C2413_CAMIFREG(0x00)
#define S3C2413_CISRCFMT_FMT_BT601		(1 << 31)
#define S3C2413_CISRCFMT_FMT_BT656		(0 << 31)
#define S3C2413_CISRCFMT_UVOFF_NONE		(0 << 30)
#define S3C2413_CISRCFMT_UVOFF_P128		(1 << 30)
#define S3C2413_CISRCFMT_BT601_16BIT		(1 << 29)
#define S3C2413_CISRCFMT_SRCHSZ_SHIFT		16
#define S3C2413_CISRCFMT_SRCHSZ_MASK		(0x1fff << S3C2413_CISRCFMT_SRCHSZ_SHIFT)
#define S3C2413_CISRCFMT_ORDER422_SHIFT		14
#define S3C2413_CISRCFMT_ORDER422_MASK		(3 << S3C2413_CISRCFMT_ORDER422_SHIFT)
#define S3C2413_CISRCFMT_ORDER422_MODE1		(0 << S3C2413_CISRCFMT_ORDER422_SHIFT)
#define S3C2413_CISRCFMT_ORDER422_MODE2		(1 << S3C2413_CISRCFMT_ORDER422_SHIFT)
#define S3C2413_CISRCFMT_ORDER422_MODE3		(2 << S3C2413_CISRCFMT_ORDER422_SHIFT)
#define S3C2413_CISRCFMT_ORDER422_MODE4		(3 << S3C2413_CISRCFMT_ORDER422_SHIFT)
#define S3C2413_CISRCFMT_SRCVSZ_SHIFT		0
#define S3C2413_CISRCFMT_SRCVSZ_MASK		(0x1fff << S3C2413_CISRCFMT_SRCVSZ_SHIFT)

#define S3C2413_CIWDOFST			S3C2413_CAMIFREG(0x04)
#define S3C2413_CIWDOFST_WINOFSEN		(1 << 31)
#define S3C2413_CIWDOFST_CLROVCOFIY		(1 << 30)
#define S3C2413_CIWDOFST_WINHOROFST_SHIFT	16
#define S3C2413_CIWDOFST_WINHOROFST_MASK	(0x7ff << S3C2413_CIWDOFST_WINHOROFST_SHIFT)
#define S3C2413_CIWDOFST_CLROVCOFICB		(1 << 15)
#define S3C2413_CIWDOFST_CLROVCOFICR		(1 << 14)
#define S3C2413_CIWDOFST_WINVEROFST_SHIFT	0
#define S3C2413_CIWDOFST_WINVEROFST_MASK	(0x7ff << S3C2413_CIWDOFST_WINVEROFST_SHIFT)

#define S3C2413_CIGCTRL				S3C2413_CAMIFREG(0x08)
#define S3C2413_CIGCTRL_SWRST			(1 << 31)
#define S3C2413_CIGCTRL_CAMRST			(1 << 30)
#define S3C2413_CIGCTRL_TEST_SHIFT		27
#define S3C2413_CIGCTRL_TEST_MASK		(3 << S3C2413_CIGCTRL_TEST_SHIFT)
#define S3C2413_CIGCTRL_TEST_NORMAL		(0 << S3C2413_CIGCTRL_TEST_SHIFT)
#define S3C2413_CIGCTRL_TEST_COLORBAR		(1 << S3C2413_CIGCTRL_TEST_SHIFT)
#define S3C2413_CIGCTRL_TEST_HINCPAT		(2 << S3C2413_CIGCTRL_TEST_SHIFT)
#define S3C2413_CIGCTRL_TEST_VINCPAT		(3 << S3C2413_CIGCTRL_TEST_SHIFT)
#define S3C2413_CIGCTRL_IRQOVFEN                (1 << 22)
#define S3C2413_CIGCTRL_HREFMASK                (1 << 21)

#define S3C2413_CIDOWSFT2			S3C2413_CAMIFREG(0x14)
#define S3C2413_CIDOWSFT2_WINHOROFST2_SHIFT	16
#define S3C2413_CIDOWSFT2_WINHOROFST2_MASK	(0x7ff << S3C2413_CIWDOFST2_WINHOROFST2_SHIFT)
#define S3C2413_CIDOWSFT2_WINVEROFST2_SHIFT	0
#define S3C2413_CIDOWSFT2_WINVEROFST2_MASK	(0x7ff << S3C2413_CIWDOFST2_WINVEROFST2_SHIFT)

#define S3C2413_CICOYSA1			S3C2413_CAMIFREG(0x18)
#define S3C2413_CICOYSA2			S3C2413_CAMIFREG(0x1c)
#define S3C2413_CICOYSA3			S3C2413_CAMIFREG(0x20)
#define S3C2413_CICOYSA4			S3C2413_CAMIFREG(0x24)

#define S3C2413_CICOCBSA1			S3C2413_CAMIFREG(0x28)
#define S3C2413_CICOCBSA2			S3C2413_CAMIFREG(0x2c)
#define S3C2413_CICOCBSA3			S3C2413_CAMIFREG(0x30)
#define S3C2413_CICOCBSA4			S3C2413_CAMIFREG(0x34)

#define S3C2413_CICOCRSA1			S3C2413_CAMIFREG(0x38)
#define S3C2413_CICOCRSA2			S3C2413_CAMIFREG(0x3c)
#define S3C2413_CICOCRSA3			S3C2413_CAMIFREG(0x40)
#define S3C2413_CICOCRSA4			S3C2413_CAMIFREG(0x44)

#define S3C2413_CICOTRGFMT			S3C2413_CAMIFREG(0x48)
#define S3C2413_CICOTRGFMT_IN422		(1 << 31)
#define S3C2413_CICOTRGFMT_OUT422		(1 << 30)
#define S3C2413_CICOTRGFMT_INTERLEAVE		(1 << 29)
#define S3C2413_CICOTRGFMT_TRGHSZ_SHIFT		16
#define S3C2413_CICOTRGFMT_TRGHSZ_MASK		(0x1fff << S3C2413_CICOTRGFMT_TRGHSZ_SHIFT)
#define S3C2413_CICOTRGFMT_FLIPMD_SHIFT		14
#define S3C2413_CICOTRGFMT_FLIPMD_MASK		(3 << S3C2413_CICOTRGFMT_FLIPMD_SHIFT)
#define S3C2413_CICOTRGFMT_FLIPMD_NONE		(0 << S3C2413_CICOTRGFMT_FLIPMD_SHIFT)
#define S3C2413_CICOTRGFMT_FLIPMD_XMIRROR	(1 << S3C2413_CICOTRGFMT_FLIPMD_SHIFT)
#define S3C2413_CICOTRGFMT_FLIPMD_YMIRROR	(2 << S3C2413_CICOTRGFMT_FLIPMD_SHIFT)
#define S3C2413_CICOTRGFMT_FLIPMD_ROT180	(3 << S3C2413_CICOTRGFMT_FLIPMD_SHIFT)
#define S3C2413_CICOTRGFMT_TRGVSZ_SHIFT		0
#define S3C2413_CICOTRGFMT_TRGVSZ_MASK		(0x1fff << S3C2413_CICOTRGFMT_TRGVSZ_SHIFT)

#define S3C2413_CICOCTRL			S3C2413_CAMIFREG(0x4c)
#define S3C2413_CICOCTRL_YBURST1_SHIFT		19
#define S3C2413_CICOCTRL_YBURST1_MASK		(0x1f << S3C2413_CICOCTRL_YBURST1_SHIFT)
#define S3C2413_CICOCTRL_YBURST2_SHIFT		14
#define S3C2413_CICOCTRL_YBURST2_MASK		(0x1f << S3C2413_CICOCTRL_YBURST2_SHIFT)
#define S3C2413_CICOCTRL_CBURST1_SHIFT		9
#define S3C2413_CICOCTRL_CBURST1_MASK		(0x1f << S3C2413_CICOCTRL_CBURST1_SHIFT)
#define S3C2413_CICOCTRL_CBURST2_SHIFT		4
#define S3C2413_CICOCTRL_CBURST2_MASK		(0x1f << S3C2413_CICOCTRL_CBURST2_SHIFT)
#define S3C2413_CICOCTRL_LASTIRQEN		(1 << 2)

#define S3C2413_CICOSCPRERATIO			S3C2413_CAMIFREG(0x50)
#define S3C2413_CICOSCPRERATIO_SHFACTOR_SHIFT	28
#define S3C2413_CICOSCPRERATIO_SHFACTOR_MASK	(0xf << S3C2413_CICOSCPRERATIO_SHFACTOR_SHIFT)
#define S3C2413_CICOSCPRERATIO_PREHORRATIO_SHIFT 16
#define S3C2413_CICOSCPRERATIO_PREHORRATIO_MASK	(0x7f << S3C2413_CICOSCPRERATIO_PREHORRATIO_SHIFT)
#define S3C2413_CICOSCPRERATIO_PREVERRATIO_SHIFT 0
#define S3C2413_CICOSCPRERATIO_PREVERRATIO_MASK	(0x7f << S3C2413_CICOSCPRERATIO_PREVERRATIO_SHIFT)

#define S3C2413_CICOSCPREDST			S3C2413_CAMIFREG(0x54)
#define S3C2413_CICOSCPREDST_PREDSTWIDTH_SHIFT	16
#define S3C2413_CICOSCPREDST_PREDSTWIDTH_MASK	(0xfff << S3C2413_CICOSCPREDST_PREDSTWIDTH_SHIFT)
#define S3C2413_CICOSCPREDST_PREDSTHEIGHT_SHIFT	0
#define S3C2413_CICOSCPREDST_PREDSTHEIGHT_MASK	(0xfff << S3C2413_CICOSCPREDST_PREDSTHEIGHT_SHIFT)

#define S3C2413_CICOSCCTRL			S3C2413_CAMIFREG(0x58)
#define S3C2413_CICOSCCTRL_SCALERBYPASS		(1 << 31)
#define S3C2413_CICOSCCTRL_SCALEUPH		(1 << 30)
#define S3C2413_CICOSCCTRL_SCALEUPV		(1 << 29)
#define S3C2413_CICOSCCTRL_MAINHORRATIO_SHIFT	16
#define S3C2413_CICOSCCTRL_MAINHORRATIO_MASK	(0x1ff << S3C2413_CICOSCCTRL_MAINHORRATIO_SHIFT)
#define S3C2413_CICOSCCTRL_COSCALERSTART	(1 << 15)
#define S3C2413_CICOSCCTRL_MAINVERRATIO_SHIFT	0
#define S3C2413_CICOSCCTRL_MAINVERRATIO_MASK	(0x1ff << S3C2413_CICOSCCTRL_MAINiVERRATIO_SHIFT)

#define S3C2413_CICOTAREA			S3C2413_CAMIFREG(0x5c)
#define S3C2413_CICOTAREA_MASK			0x3ffffff

#define S3C2413_CICOSTATUS			S3C2413_CAMIFREG(0x64)
#define S3C2413_CICOSTATUS_FRAMECNT_SHIFT	26
#define S3C2413_CICOSTATUS_FRAMECNT_MASK	(3 << S3C2413_CICOSTATUS_FRAMECNT_SHIFT)

#define S3C2413_CIIMGCPT			S3C2413_CAMIFREG(0xa0)
#define S3C2413_CIIMGCPT_IMGCPTEN		(1 << 31)
#define S3C2413_CIIMGCPT_IMGCPTEN_COSC		(1 << 30)
#define S3C2413_CIIMGCPT_RGB			(1 << 26)
#define S3C2413_CIIMGCPT_YUV			(0 << 26)
#define S3C2413_CIIMGCPT_RGBFMT_24BIT		(1 << 25)
#define S3C2413_CIIMGCPT_RGBFMT_16BIT		(0 << 25)
#define S3C2413_CIIMGCPT_DMAEN			(1 << 24)
#define S3C2413_CIIMGCPT_DMAPTR_SHIFT		19
#define S3C2413_CIIMGCPT_DMAPTR_MASK		(5 << S3C2413_CIIMGCPT_DMAPTR_SHIFT)
#define S3C2413_CIIMGCPT_DMAMODE_COUNT		(1 << 18)
#define S3C2413_CIIMGCPT_FRAMECNT_SHIFT		10
#define S3C2413_CIIMGCPT_FRAMECNT_MASK		(0xff << S3C2413_CIIMGCPT_FRAMECNT_SHIFT)

#define S3C2413_CICOCPTSEQ			S3C2413_CAMIFREG(0xa4)
#define S3C2413_CICOSCOS			S3C2413_CAMIFREG(0xa8)

#endif /* __ASM_ARCH_REGS_CAMIF_H */
