/* include/barcelona/Barc_diag.h
 *
 * Public interface for the battery driver.
 *
 * Copyright (C) 2007 TomTom BV <http://www.tomtom.com/>
 * Author: Bjorn Martens <bjorn.martens@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __INCLUDE_BARCELONA_BARC_DIAGNOSTICS_H
#define __INCLUDE_BARCELONA_BARC_DIAGNOSTICS_H

#ifndef __INCLUDE_BARCELONA_TYPES_H
#include <barcelona/types.h>
#endif /* __INCLUDE_BARCELONA_TYPES_H */

#include <linux/ioctl.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define DIAGNOSTICS_DEVNAME	"diag"
//FIXME Check if this major number could be taken for diagnostics
#define DIAGNOSTICS_MAJOR	242

#define DIAGNOSTICS_DRIVER_MAGIC	'D' /* Diagnostics driver magic number */

#define MUX_GPIO_0 _IOW(DIAGNOSTICS_DRIVER_MAGIC, 0, int)
#define MUX_GPIO_1 _IOW(DIAGNOSTICS_DRIVER_MAGIC, 1, int)
#define MUX_GPIO_2 _IOW(DIAGNOSTICS_DRIVER_MAGIC, 2, int)
#define GPIO_GPS_EXT_ANT _IOW(DIAGNOSTICS_DRIVER_MAGIC, 3, int)

#define IO_DIAGNOSTICS_READ_ADC _IOR(DIAGNOSTICS_DRIVER_MAGIC, 10, int)
#define IO_DIAGNOSTICS_GET_ADC_RATE _IOR(DIAGNOSTICS_DRIVER_MAGIC, 11, int)

#define IO_USB_POWERLINE _IOR(DIAGNOSTICS_DRIVER_MAGIC, 100, int)
#define IO_CAR_BATTERY _IOR(DIAGNOSTICS_DRIVER_MAGIC, 101, int)
#define IO_TEMPERATURE _IOR(DIAGNOSTICS_DRIVER_MAGIC, 102, int)
#define IO_REFERENCE _IOR(DIAGNOSTICS_DRIVER_MAGIC, 103, int)
#define IO_SDCARD _IOR(DIAGNOSTICS_DRIVER_MAGIC, 104, int)
#define IO_MUTE _IOR(DIAGNOSTICS_DRIVER_MAGIC, 105, int)
#define IO_TEMPERATURE_DEG _IOR(DIAGNOSTICS_DRIVER_MAGIC, 106, int)


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __INCLUDE_BARCELONA_BARC_DIAGNOSTICS_H */

/* EOF */ 
