/* include/barcelona/Barc_micro.h
 *
 * Public interface for the Can processor Micro driver.
 *
 * Copyright (C) 2007 TomTom BV <http://www.tomtom.com/>
 * Author: Peter Wouters <peter.wouters@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __INCLUDE_BARCELONA_BARC_MICRO_H
#define __INCLUDE_BARCELONA_BARC_MICRO_H

#ifndef __INCLUDE_BARCELONA_TYPES_H
#include <barcelona/types.h>
#endif /* __INCLUDE_BARCELONA_TYPES_H */

#include <linux/ioctl.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define MICRO_DEVNAME      "micro"
#define MICRO_MAJOR        253

#define MICRO_DRIVER_MAGIC 'M' /* micro driver magic number */

// Output pins
#define IO_nCAN_RST       _IOW(MICRO_DRIVER_MAGIC, 1, int)    // LOW: Resets the CAN processor
#define IO_CAN_SYNC       _IOW(MICRO_DRIVER_MAGIC, 2, int)    // HighLow: Sync pulse
#define IO_CAN_BT_MD      _IOW(MICRO_DRIVER_MAGIC, 3, int)    // CAN processor Boot Mode (Low=normal mode; High=SW loading mode)
#define IO_PWR_5V_ON_MCU  _IOW(MICRO_DRIVER_MAGIC, 4, int)    // High: Enable 5V power to CAN processor
#define IO_MCU_nPWR_ON    _IOW(MICRO_DRIVER_MAGIC, 5, int)    // Low: Enable 3V3 power to CAN processor

// Input pins
#define IO_CAN_nRST       _IOR(MICRO_DRIVER_MAGIC, 10, int)   // LOW: CAN processor has been reset
#define IO_CAN_RES        _IOR(MICRO_DRIVER_MAGIC, 11, int)   // Spare pin


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __INCLUDE_BARCELONA_BARC_MICRO_H */

/* EOF */ 
