/* include/barcelona/video_overlay.h
 *
 * Public interface for video overlaying
 *
 * Copyright (C) 2007 TomTom BV <http://www.tomtom.com/>
 * Author: Onno Hovers <onno.hovers@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __INCLUDE_BARCELONA_VIDEO_OVERLAY_H
#define __INCLUDE_BARCELONA_VIDEO_OVERLAY_H

#define TFT_IGNORE_INPUTSYNC 0
#define TFT_ADJUST_TO_INPUTSYNC 1


/* support for video overlaying */
struct video_overlay_ops
{
	void              (*get_resolution)(int *w, int *h, int *bpp);
	int               (*get_number_of_buffers)(void);
	void              (*get_buffer)(int buf, void **kptr, unsigned long int *dma, unsigned long *size);
	void              (*set_buffer)(int buf);
	void              (*flip_buffer)(void);
	void              (*set_window)(int src_left, int src_top, int dst_left, int dst_top, int width, int height, int fb_width );
	void              (*set_color_key)(int enable, unsigned key);
	void              (*set_global_alpha)(unsigned char value);
	void              (*dump_regs)(void);
	int               (*set_framerate)(int framerate);
	void              (*input_sync)(void);
	void              (*set_input_synchronisation)(int state);
	
};

extern struct video_overlay_ops *video_overlay;

#endif
